\ CONTENT : contains some io routines specifically for the Vnumbers
\ LANGUAGE : tForth
\ PROJECT : hcc primes
\ CATEGORY : EXAMPLE
\ AUTOR :  AH
\ LAST CHANGE : 911116 A VNUM of 0 left stackgarbage
\ LAST CHANGE : 911115 AH created

Vnumber IOscratch PRIVATE

: 9Digits   ( I -- )
     0 <# 3 0 DO # # # &. HOLD LOOP #> TYPE ;
: 3Digits   ( I -- )
    0 <# # # # &. HOLD #> TYPE ;


\ Auxiliary routine for .VNUM
\ Uses the stack for reversing the order of digits (here a digits=10^9)
: (.VNUM)
  IOscratch @ 1 = IF
     IOscratch CELL+ @  1000 U< 0= IF
         IOscratch 1000 VS/MOD
         RECURSE
         3Digits
     ELSE
         IOscratch CELL+ @
         0 <# #S #> TYPE
     ENDIF
  ELSE                          \ Leave this else part out on a 16 bit machine
     IOscratch 1000000000 VS/MOD
     RECURSE
     9Digits
  ENDIF
; PRIVATE

: .VNUM  ( VV --  )
   DUP @ 0= IF
      DROP ." 0"
   ELSE
      IOscratch VVmove
      (.VNUM)
   ENDIF
;

: VREAD        ( -- )
   0 IOscratch !
   BL WORD COUNT  DUP #90 > ABORT" Are you nuts or something"
   0 ?DO
      C@+ BASE @ DIGIT? 0= ABORT" Strange char"
     IOscratch 10 VS*
     IOscratch SWAP VS+
    LOOP
   DROP
   IOscratch SWAP VVmove
;
